/*
 * Author: Utkarsh Gupta
 * Created on: June 5, 2012
 * File Name : make_switch_module.h
 * Project Name : Automation of Folding (DDP)
 * Description : Header File for make_switch_module.cpp
 */

#ifndef SWITCH_MODULE
#define SWITCH_MODULE
    void make_switch_module(int folded_nodes, int num_edges, int switch_type, const char* outputfile);
    void make_demux_module( int edge_conn[], int num_edges, int folded_nodes, int side_num, const char* outputfile);
    void make_mux_module( int edge_conn[], int num_edges, int folded_nodes, int side_num, const char* outputfile);
    void make_rom_module(int conn[], int order, int nodes_folded, int rom_type, const char* outputfile);
#endif

