-- Storing an estimated codeword, in case during next 'check' phase, all parity checks turn out to be satisfied.

be1: rxvd_code( 18 downto 0 ) <= rxvd_fold WHEN ( en_out_b = '1' AND fold_indx_b = "00" ) ELSE rxvd_code( 18 downto 0 );

be2: rxvd_code( 37 downto 19 ) <= rxvd_fold WHEN ( en_out_b = '1' AND fold_indx_b = "01" ) ELSE rxvd_code( 37 downto 19 );

be3: rxvd_code( 56 downto 38 ) <= rxvd_fold WHEN ( en_out_b = '1' AND fold_indx_b = "10" ) ELSE rxvd_code( 56 downto 38 );

-- Accumulating all parity check outputs, to see if the decoding has converged.

pc1: pcheck_out( 18 downto 0 ) <= cmu_in1 WHEN ( clk'EVENT AND clk = '1' AND en_out_c = '1' AND fold_indx_c = "00" ) ELSE pcheck_out( 18 downto 0 );

pc2: pcheck_out( 37 downto 19 ) <= cmu_in1 WHEN ( clk'EVENT AND clk = '1' AND en_out_c = '1' AND fold_indx_c = "01" ) ELSE pcheck_out( 37 downto 19 );

pc3: pcheck_out( 56 downto 38 ) <= cmu_in1 WHEN ( clk'EVENT AND clk = '1' AND en_out_c = '1' AND fold_indx_c = "10" ) ELSE pcheck_out( 56 downto 38 );

