------------process for multiplexing intrinsic information ----------------
-- Providing the intrinsic information half a clock cycle ahead, to avoid setup time violation.
PROCESS( clk )
BEGIN
    IF( clk'EVENT AND clk = '0' ) THEN
      IF( en_first_time_b = '1' ) THEN
        IF( fold_indx_b = "00" ) THEN
         fold_intr_in( 0 ) <= intr_in( 0 );
         fold_intr_in( 1 ) <= intr_in( 1 );
         fold_intr_in( 2 ) <= intr_in( 2 );
         fold_intr_in( 3 ) <= intr_in( 3 );
         fold_intr_in( 4 ) <= intr_in( 4 );
         fold_intr_in( 5 ) <= intr_in( 5 );
         fold_intr_in( 6 ) <= intr_in( 6 );
         fold_intr_in( 7 ) <= intr_in( 7 );
         fold_intr_in( 8 ) <= intr_in( 8 );
         fold_intr_in( 9 ) <= intr_in( 9 );
         fold_intr_in( 10 ) <= intr_in( 10 );
         fold_intr_in( 11 ) <= intr_in( 11 );
         fold_intr_in( 12 ) <= intr_in( 12 );
         fold_intr_in( 13 ) <= intr_in( 13 );
         fold_intr_in( 14 ) <= intr_in( 14 );
         fold_intr_in( 15 ) <= intr_in( 15 );
         fold_intr_in( 16 ) <= intr_in( 16 );
         fold_intr_in( 17 ) <= intr_in( 17 );
         fold_intr_in( 18 ) <= intr_in( 18 );
        ELSIF( fold_indx_b = "01" ) THEN
         fold_intr_in( 0 ) <= intr_in( 19 );
         fold_intr_in( 1 ) <= intr_in( 20 );
         fold_intr_in( 2 ) <= intr_in( 21 );
         fold_intr_in( 3 ) <= intr_in( 22 );
         fold_intr_in( 4 ) <= intr_in( 23 );
         fold_intr_in( 5 ) <= intr_in( 24 );
         fold_intr_in( 6 ) <= intr_in( 25 );
         fold_intr_in( 7 ) <= intr_in( 26 );
         fold_intr_in( 8 ) <= intr_in( 27 );
         fold_intr_in( 9 ) <= intr_in( 28 );
         fold_intr_in( 10 ) <= intr_in( 29 );
         fold_intr_in( 11 ) <= intr_in( 30 );
         fold_intr_in( 12 ) <= intr_in( 31 );
         fold_intr_in( 13 ) <= intr_in( 32 );
         fold_intr_in( 14 ) <= intr_in( 33 );
         fold_intr_in( 15 ) <= intr_in( 34 );
         fold_intr_in( 16 ) <= intr_in( 35 );
         fold_intr_in( 17 ) <= intr_in( 36 );
         fold_intr_in( 18 ) <= intr_in( 37 );
        ELSIF( fold_indx_b = "10" ) THEN
         fold_intr_in( 0 ) <= intr_in( 38 );
         fold_intr_in( 1 ) <= intr_in( 39 );
         fold_intr_in( 2 ) <= intr_in( 40 );
         fold_intr_in( 3 ) <= intr_in( 41 );
         fold_intr_in( 4 ) <= intr_in( 42 );
         fold_intr_in( 5 ) <= intr_in( 43 );
         fold_intr_in( 6 ) <= intr_in( 44 );
         fold_intr_in( 7 ) <= intr_in( 45 );
         fold_intr_in( 8 ) <= intr_in( 46 );
         fold_intr_in( 9 ) <= intr_in( 47 );
         fold_intr_in( 10 ) <= intr_in( 48 );
         fold_intr_in( 11 ) <= intr_in( 49 );
         fold_intr_in( 12 ) <= intr_in( 50 );
         fold_intr_in( 13 ) <= intr_in( 51 );
         fold_intr_in( 14 ) <= intr_in( 52 );
         fold_intr_in( 15 ) <= intr_in( 53 );
         fold_intr_in( 16 ) <= intr_in( 54 );
         fold_intr_in( 17 ) <= intr_in( 55 );
         fold_intr_in( 18 ) <= intr_in( 56 );
        ELSE
         fold_intr_in( 0 ) <= "ZZZZZZZZZ";
         fold_intr_in( 1 ) <= "ZZZZZZZZZ";
         fold_intr_in( 2 ) <= "ZZZZZZZZZ";
         fold_intr_in( 3 ) <= "ZZZZZZZZZ";
         fold_intr_in( 4 ) <= "ZZZZZZZZZ";
         fold_intr_in( 5 ) <= "ZZZZZZZZZ";
         fold_intr_in( 6 ) <= "ZZZZZZZZZ";
         fold_intr_in( 7 ) <= "ZZZZZZZZZ";
         fold_intr_in( 8 ) <= "ZZZZZZZZZ";
         fold_intr_in( 9 ) <= "ZZZZZZZZZ";
         fold_intr_in( 10 ) <= "ZZZZZZZZZ";
         fold_intr_in( 11 ) <= "ZZZZZZZZZ";
         fold_intr_in( 12 ) <= "ZZZZZZZZZ";
         fold_intr_in( 13 ) <= "ZZZZZZZZZ";
         fold_intr_in( 14 ) <= "ZZZZZZZZZ";
         fold_intr_in( 15 ) <= "ZZZZZZZZZ";
         fold_intr_in( 16 ) <= "ZZZZZZZZZ";
         fold_intr_in( 17 ) <= "ZZZZZZZZZ";
         fold_intr_in( 18 ) <= "ZZZZZZZZZ";
        END IF;
      END IF;
    END IF;
END PROCESS;
