-- This is a generic demux code
LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
USE WORK.fold_package.ALL;

ENTITY
h_demux IS
    PORT (  clk          : IN STD_LOGIC;
            line_sel1    : IN INTEGER;
            line_sel2    : IN INTEGER;
            demux_id     : IN node_indx;
            en_demux     : IN STD_LOGIC;
            in_val1      : IN STD_LOGIC;
            in_val2      : IN STD_LOGIC;
            out_val_1     : OUT STD_LOGIC;
            out_val_2     : OUT STD_LOGIC;
            out_val_3     : OUT STD_LOGIC;
            out_val_4     : OUT STD_LOGIC;
            out_val_5     : OUT STD_LOGIC;
            out_val_6     : OUT STD_LOGIC;
            out_val_7     : OUT STD_LOGIC;
            out_val_8     : OUT STD_LOGIC
        );
END ENTITY h_demux;

ARCHITECTURE behav OF h_demux IS
BEGIN

PROCESS( clk )
BEGIN
    IF(clk'event and clk='1') THEN
      IF( en_demux = '1' ) THEN

            out_val_1 <= 'Z';
            out_val_2 <= 'Z';
            out_val_3 <= 'Z';
            out_val_4 <= 'Z';
            out_val_5 <= 'Z';
            out_val_6 <= 'Z';
            out_val_7 <= 'Z';
            out_val_8 <= 'Z';
        IF( line_sel1 = 0 ) THEN
            IF( demux_id = "00000") THEN
                out_val_1 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "00001") THEN
                out_val_1 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "00010") THEN
                out_val_1 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "00100") THEN
                out_val_1 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "00101") THEN
                out_val_1 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "01000") THEN
                out_val_1 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "01010") THEN
                out_val_1 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "01110") THEN
                out_val_1 <=    in_val1;
                 -- No access Defined --;
            ELSE
                out_val_1 <= 'Z';
            END IF;
        ELSIF( line_sel1 = 1 ) THEN
            IF( demux_id = "00001") THEN
                out_val_2 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "00010") THEN
                out_val_2 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "00011") THEN
                out_val_1 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "00101") THEN
                out_val_2 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "00110") THEN
                out_val_1 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "01001") THEN
                out_val_1 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "01011") THEN
                out_val_1 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "01111") THEN
                out_val_1 <=    in_val1;
                 -- No access Defined --;
            ELSE
                out_val_1 <= 'Z';
            END IF;
        ELSIF( line_sel1 = 2 ) THEN
            IF( demux_id = "00010") THEN
                out_val_3 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "00011") THEN
                out_val_2 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "00100") THEN
                out_val_2 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "00110") THEN
                out_val_2 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "00111") THEN
                out_val_1 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "01010") THEN
                out_val_2 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "01100") THEN
                out_val_1 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "10000") THEN
                out_val_1 <=    in_val1;
                 -- No access Defined --;
            ELSE
                out_val_1 <= 'Z';
            END IF;
        ELSIF( line_sel1 = 3 ) THEN
            IF( demux_id = "00011") THEN
                out_val_3 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "00100") THEN
                out_val_3 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "00101") THEN
                out_val_3 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "00111") THEN
                out_val_2 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "01000") THEN
                out_val_2 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "01011") THEN
                out_val_2 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "01101") THEN
                out_val_1 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "10001") THEN
                out_val_1 <=    in_val1;
                 -- No access Defined --;
            ELSE
                out_val_1 <= 'Z';
            END IF;
        ELSIF( line_sel1 = 4 ) THEN
            IF( demux_id = "00100") THEN
                out_val_4 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "00101") THEN
                out_val_4 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "00110") THEN
                out_val_3 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "01000") THEN
                out_val_3 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "01001") THEN
                out_val_2 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "01100") THEN
                out_val_2 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "01110") THEN
                out_val_2 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "10010") THEN
                out_val_1 <=    in_val1;
                 -- No access Defined --;
            ELSE
                out_val_1 <= 'Z';
            END IF;
        ELSIF( line_sel1 = 5 ) THEN
            IF( demux_id = "00000") THEN
                out_val_2 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "00101") THEN
                out_val_5 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "00110") THEN
                out_val_4 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "00111") THEN
                out_val_3 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "01001") THEN
                out_val_3 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "01010") THEN
                out_val_3 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "01101") THEN
                out_val_2 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "01111") THEN
                out_val_2 <=    in_val1;
                 -- No access Defined --;
            ELSE
                out_val_1 <= 'Z';
            END IF;
        ELSIF( line_sel1 = 6 ) THEN
            IF( demux_id = "00001") THEN
                out_val_3 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "00110") THEN
                out_val_5 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "00111") THEN
                out_val_4 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "01000") THEN
                out_val_4 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "01010") THEN
                out_val_4 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "01011") THEN
                out_val_3 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "01110") THEN
                out_val_3 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "10000") THEN
                out_val_2 <=    in_val1;
                 -- No access Defined --;
            ELSE
                out_val_1 <= 'Z';
            END IF;
        ELSIF( line_sel1 = 7 ) THEN
            IF( demux_id = "00010") THEN
                out_val_4 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "00111") THEN
                out_val_5 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "01000") THEN
                out_val_5 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "01001") THEN
                out_val_4 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "01011") THEN
                out_val_4 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "01100") THEN
                out_val_3 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "01111") THEN
                out_val_3 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "10001") THEN
                out_val_2 <=    in_val1;
                 -- No access Defined --;
            ELSE
                out_val_1 <= 'Z';
            END IF;
        ELSIF( line_sel1 = 8 ) THEN
            IF( demux_id = "00011") THEN
                out_val_4 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "01000") THEN
                out_val_6 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "01001") THEN
                out_val_5 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "01010") THEN
                out_val_5 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "01100") THEN
                out_val_4 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "01101") THEN
                out_val_3 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "10000") THEN
                out_val_3 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "10010") THEN
                out_val_2 <=    in_val1;
                 -- No access Defined --;
            ELSE
                out_val_1 <= 'Z';
            END IF;
        ELSIF( line_sel1 = 9 ) THEN
            IF( demux_id = "00000") THEN
                out_val_3 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "00100") THEN
                out_val_5 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "01001") THEN
                out_val_6 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "01010") THEN
                out_val_6 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "01011") THEN
                out_val_5 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "01101") THEN
                out_val_4 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "01110") THEN
                out_val_4 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "10001") THEN
                out_val_3 <=    in_val1;
                 -- No access Defined --;
            ELSE
                out_val_1 <= 'Z';
            END IF;
        ELSIF( line_sel1 = 10 ) THEN
            IF( demux_id = "00001") THEN
                out_val_4 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "00101") THEN
                out_val_6 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "01010") THEN
                out_val_7 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "01011") THEN
                out_val_6 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "01100") THEN
                out_val_5 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "01110") THEN
                out_val_5 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "01111") THEN
                out_val_4 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "10010") THEN
                out_val_3 <=    in_val1;
                 -- No access Defined --;
            ELSE
                out_val_1 <= 'Z';
            END IF;
        ELSIF( line_sel1 = 11 ) THEN
            IF( demux_id = "00000") THEN
                out_val_4 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "00010") THEN
                out_val_5 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "00110") THEN
                out_val_6 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "01011") THEN
                out_val_7 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "01100") THEN
                out_val_6 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "01101") THEN
                out_val_5 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "01111") THEN
                out_val_5 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "10000") THEN
                out_val_4 <=    in_val1;
                 -- No access Defined --;
            ELSE
                out_val_1 <= 'Z';
            END IF;
        ELSIF( line_sel1 = 12 ) THEN
            IF( demux_id = "00001") THEN
                out_val_5 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "00011") THEN
                out_val_5 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "00111") THEN
                out_val_6 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "01100") THEN
                out_val_7 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "01101") THEN
                out_val_6 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "01110") THEN
                out_val_6 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "10000") THEN
                out_val_5 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "10001") THEN
                out_val_4 <=    in_val1;
                 -- No access Defined --;
            ELSE
                out_val_1 <= 'Z';
            END IF;
        ELSIF( line_sel1 = 13 ) THEN
            IF( demux_id = "00010") THEN
                out_val_6 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "00100") THEN
                out_val_6 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "01000") THEN
                out_val_7 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "01101") THEN
                out_val_7 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "01110") THEN
                out_val_7 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "01111") THEN
                out_val_6 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "10001") THEN
                out_val_5 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "10010") THEN
                out_val_4 <=    in_val1;
                 -- No access Defined --;
            ELSE
                out_val_1 <= 'Z';
            END IF;
        ELSIF( line_sel1 = 14 ) THEN
            IF( demux_id = "00000") THEN
                out_val_5 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "00011") THEN
                out_val_6 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "00101") THEN
                out_val_7 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "01001") THEN
                out_val_7 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "01110") THEN
                out_val_8 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "01111") THEN
                out_val_7 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "10000") THEN
                out_val_6 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "10010") THEN
                out_val_5 <=    in_val1;
                 -- No access Defined --;
            ELSE
                out_val_1 <= 'Z';
            END IF;
        ELSIF( line_sel1 = 15 ) THEN
            IF( demux_id = "00000") THEN
                out_val_6 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "00001") THEN
                out_val_6 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "00100") THEN
                out_val_7 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "00110") THEN
                out_val_7 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "01010") THEN
                out_val_8 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "01111") THEN
                out_val_8 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "10000") THEN
                out_val_7 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "10001") THEN
                out_val_6 <=    in_val1;
                 -- No access Defined --;
            ELSE
                out_val_1 <= 'Z';
            END IF;
        ELSIF( line_sel1 = 16 ) THEN
            IF( demux_id = "00001") THEN
                out_val_7 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "00010") THEN
                out_val_7 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "00101") THEN
                out_val_8 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "00111") THEN
                out_val_7 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "01011") THEN
                out_val_8 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "10000") THEN
                out_val_8 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "10001") THEN
                out_val_7 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "10010") THEN
                out_val_6 <=    in_val1;
                 -- No access Defined --;
            ELSE
                out_val_1 <= 'Z';
            END IF;
        ELSIF( line_sel1 = 17 ) THEN
            IF( demux_id = "00000") THEN
                out_val_7 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "00010") THEN
                out_val_8 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "00011") THEN
                out_val_7 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "00110") THEN
                out_val_8 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "01000") THEN
                out_val_8 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "01100") THEN
                out_val_8 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "10001") THEN
                out_val_8 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "10010") THEN
                out_val_7 <=    in_val1;
                 -- No access Defined --;
            ELSE
                out_val_1 <= 'Z';
            END IF;
        ELSIF( line_sel1 = 18 ) THEN
            IF( demux_id = "00000") THEN
                out_val_8 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "00001") THEN
                out_val_8 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "00011") THEN
                out_val_8 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "00100") THEN
                out_val_8 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "00111") THEN
                out_val_8 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "01001") THEN
                out_val_8 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "01101") THEN
                out_val_8 <=    in_val1;
                 -- No access Defined --;
            ELSIF( demux_id = "10010") THEN
                out_val_8 <=    in_val1;
                 -- No access Defined --;
            ELSE
                out_val_1 <= 'Z';
            END IF;
        END IF;

        IF( line_sel2 = 0 ) THEN
            IF( demux_id = "00000") THEN
                out_val_1 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "00001") THEN
                out_val_1 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "00010") THEN
                out_val_1 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "00100") THEN
                out_val_1 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "00101") THEN
                out_val_1 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "01000") THEN
                out_val_1 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "01010") THEN
                out_val_1 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "01110") THEN
                out_val_1 <=    in_val2;
                 -- No access Defined --;
            ELSE
                out_val_2 <= 'Z';
            END IF;
        ELSIF( line_sel2 = 1 ) THEN
            IF( demux_id = "00001") THEN
                out_val_2 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "00010") THEN
                out_val_2 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "00011") THEN
                out_val_1 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "00101") THEN
                out_val_2 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "00110") THEN
                out_val_1 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "01001") THEN
                out_val_1 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "01011") THEN
                out_val_1 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "01111") THEN
                out_val_1 <=    in_val2;
                 -- No access Defined --;
            ELSE
                out_val_2 <= 'Z';
            END IF;
        ELSIF( line_sel2 = 2 ) THEN
            IF( demux_id = "00010") THEN
                out_val_3 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "00011") THEN
                out_val_2 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "00100") THEN
                out_val_2 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "00110") THEN
                out_val_2 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "00111") THEN
                out_val_1 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "01010") THEN
                out_val_2 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "01100") THEN
                out_val_1 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "10000") THEN
                out_val_1 <=    in_val2;
                 -- No access Defined --;
            ELSE
                out_val_2 <= 'Z';
            END IF;
        ELSIF( line_sel2 = 3 ) THEN
            IF( demux_id = "00011") THEN
                out_val_3 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "00100") THEN
                out_val_3 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "00101") THEN
                out_val_3 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "00111") THEN
                out_val_2 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "01000") THEN
                out_val_2 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "01011") THEN
                out_val_2 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "01101") THEN
                out_val_1 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "10001") THEN
                out_val_1 <=    in_val2;
                 -- No access Defined --;
            ELSE
                out_val_2 <= 'Z';
            END IF;
        ELSIF( line_sel2 = 4 ) THEN
            IF( demux_id = "00100") THEN
                out_val_4 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "00101") THEN
                out_val_4 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "00110") THEN
                out_val_3 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "01000") THEN
                out_val_3 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "01001") THEN
                out_val_2 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "01100") THEN
                out_val_2 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "01110") THEN
                out_val_2 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "10010") THEN
                out_val_1 <=    in_val2;
                 -- No access Defined --;
            ELSE
                out_val_2 <= 'Z';
            END IF;
        ELSIF( line_sel2 = 5 ) THEN
            IF( demux_id = "00000") THEN
                out_val_2 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "00101") THEN
                out_val_5 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "00110") THEN
                out_val_4 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "00111") THEN
                out_val_3 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "01001") THEN
                out_val_3 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "01010") THEN
                out_val_3 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "01101") THEN
                out_val_2 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "01111") THEN
                out_val_2 <=    in_val2;
                 -- No access Defined --;
            ELSE
                out_val_2 <= 'Z';
            END IF;
        ELSIF( line_sel2 = 6 ) THEN
            IF( demux_id = "00001") THEN
                out_val_3 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "00110") THEN
                out_val_5 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "00111") THEN
                out_val_4 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "01000") THEN
                out_val_4 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "01010") THEN
                out_val_4 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "01011") THEN
                out_val_3 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "01110") THEN
                out_val_3 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "10000") THEN
                out_val_2 <=    in_val2;
                 -- No access Defined --;
            ELSE
                out_val_2 <= 'Z';
            END IF;
        ELSIF( line_sel2 = 7 ) THEN
            IF( demux_id = "00010") THEN
                out_val_4 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "00111") THEN
                out_val_5 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "01000") THEN
                out_val_5 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "01001") THEN
                out_val_4 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "01011") THEN
                out_val_4 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "01100") THEN
                out_val_3 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "01111") THEN
                out_val_3 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "10001") THEN
                out_val_2 <=    in_val2;
                 -- No access Defined --;
            ELSE
                out_val_2 <= 'Z';
            END IF;
        ELSIF( line_sel2 = 8 ) THEN
            IF( demux_id = "00011") THEN
                out_val_4 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "01000") THEN
                out_val_6 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "01001") THEN
                out_val_5 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "01010") THEN
                out_val_5 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "01100") THEN
                out_val_4 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "01101") THEN
                out_val_3 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "10000") THEN
                out_val_3 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "10010") THEN
                out_val_2 <=    in_val2;
                 -- No access Defined --;
            ELSE
                out_val_2 <= 'Z';
            END IF;
        ELSIF( line_sel2 = 9 ) THEN
            IF( demux_id = "00000") THEN
                out_val_3 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "00100") THEN
                out_val_5 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "01001") THEN
                out_val_6 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "01010") THEN
                out_val_6 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "01011") THEN
                out_val_5 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "01101") THEN
                out_val_4 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "01110") THEN
                out_val_4 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "10001") THEN
                out_val_3 <=    in_val2;
                 -- No access Defined --;
            ELSE
                out_val_2 <= 'Z';
            END IF;
        ELSIF( line_sel2 = 10 ) THEN
            IF( demux_id = "00001") THEN
                out_val_4 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "00101") THEN
                out_val_6 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "01010") THEN
                out_val_7 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "01011") THEN
                out_val_6 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "01100") THEN
                out_val_5 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "01110") THEN
                out_val_5 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "01111") THEN
                out_val_4 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "10010") THEN
                out_val_3 <=    in_val2;
                 -- No access Defined --;
            ELSE
                out_val_2 <= 'Z';
            END IF;
        ELSIF( line_sel2 = 11 ) THEN
            IF( demux_id = "00000") THEN
                out_val_4 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "00010") THEN
                out_val_5 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "00110") THEN
                out_val_6 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "01011") THEN
                out_val_7 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "01100") THEN
                out_val_6 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "01101") THEN
                out_val_5 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "01111") THEN
                out_val_5 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "10000") THEN
                out_val_4 <=    in_val2;
                 -- No access Defined --;
            ELSE
                out_val_2 <= 'Z';
            END IF;
        ELSIF( line_sel2 = 12 ) THEN
            IF( demux_id = "00001") THEN
                out_val_5 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "00011") THEN
                out_val_5 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "00111") THEN
                out_val_6 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "01100") THEN
                out_val_7 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "01101") THEN
                out_val_6 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "01110") THEN
                out_val_6 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "10000") THEN
                out_val_5 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "10001") THEN
                out_val_4 <=    in_val2;
                 -- No access Defined --;
            ELSE
                out_val_2 <= 'Z';
            END IF;
        ELSIF( line_sel2 = 13 ) THEN
            IF( demux_id = "00010") THEN
                out_val_6 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "00100") THEN
                out_val_6 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "01000") THEN
                out_val_7 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "01101") THEN
                out_val_7 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "01110") THEN
                out_val_7 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "01111") THEN
                out_val_6 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "10001") THEN
                out_val_5 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "10010") THEN
                out_val_4 <=    in_val2;
                 -- No access Defined --;
            ELSE
                out_val_2 <= 'Z';
            END IF;
        ELSIF( line_sel2 = 14 ) THEN
            IF( demux_id = "00000") THEN
                out_val_5 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "00011") THEN
                out_val_6 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "00101") THEN
                out_val_7 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "01001") THEN
                out_val_7 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "01110") THEN
                out_val_8 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "01111") THEN
                out_val_7 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "10000") THEN
                out_val_6 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "10010") THEN
                out_val_5 <=    in_val2;
                 -- No access Defined --;
            ELSE
                out_val_2 <= 'Z';
            END IF;
        ELSIF( line_sel2 = 15 ) THEN
            IF( demux_id = "00000") THEN
                out_val_6 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "00001") THEN
                out_val_6 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "00100") THEN
                out_val_7 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "00110") THEN
                out_val_7 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "01010") THEN
                out_val_8 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "01111") THEN
                out_val_8 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "10000") THEN
                out_val_7 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "10001") THEN
                out_val_6 <=    in_val2;
                 -- No access Defined --;
            ELSE
                out_val_2 <= 'Z';
            END IF;
        ELSIF( line_sel2 = 16 ) THEN
            IF( demux_id = "00001") THEN
                out_val_7 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "00010") THEN
                out_val_7 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "00101") THEN
                out_val_8 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "00111") THEN
                out_val_7 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "01011") THEN
                out_val_8 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "10000") THEN
                out_val_8 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "10001") THEN
                out_val_7 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "10010") THEN
                out_val_6 <=    in_val2;
                 -- No access Defined --;
            ELSE
                out_val_2 <= 'Z';
            END IF;
        ELSIF( line_sel2 = 17 ) THEN
            IF( demux_id = "00000") THEN
                out_val_7 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "00010") THEN
                out_val_8 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "00011") THEN
                out_val_7 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "00110") THEN
                out_val_8 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "01000") THEN
                out_val_8 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "01100") THEN
                out_val_8 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "10001") THEN
                out_val_8 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "10010") THEN
                out_val_7 <=    in_val2;
                 -- No access Defined --;
            ELSE
                out_val_2 <= 'Z';
            END IF;
        ELSIF( line_sel2 = 18 ) THEN
            IF( demux_id = "00000") THEN
                out_val_8 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "00001") THEN
                out_val_8 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "00011") THEN
                out_val_8 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "00100") THEN
                out_val_8 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "00111") THEN
                out_val_8 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "01001") THEN
                out_val_8 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "01101") THEN
                out_val_8 <=    in_val2;
                 -- No access Defined --;
            ELSIF( demux_id = "10010") THEN
                out_val_8 <=    in_val2;
                 -- No access Defined --;
            ELSE
                out_val_2 <= 'Z';
            END IF;
        END IF;

    ELSE
            out_val_1 <= 'Z';
            out_val_2 <= 'Z';
            out_val_3 <= 'Z';
            out_val_4 <= 'Z';
            out_val_5 <= 'Z';
            out_val_6 <= 'Z';
            out_val_7 <= 'Z';
            out_val_8 <= 'Z';
      END IF;
    END IF;
END PROCESS;

END ARCHITECTURE behav;
