----------------process for codeword convergence test ---------------------
PROCESS( decide_cword, en_sequencing )
BEGIN
    IF( en_sequencing = '1' ) THEN
      IF decide_cword = '1' THEN
        IF( pcheck_out = "000000000000000" ) THEN
          valid_word <= '1';
        ELSE
          valid_word <= '0';
        END IF;
      ELSE
        valid_word <= '0';  -- to avoid latch generation
      END IF;
    ELSE
      valid_word  <= '0';
    END IF;
END PROCESS;

---------------process for iteration counting------------------
PROCESS( en_sequencing, ctrl_store_addr )
BEGIN
    IF( en_sequencing = '0' ) THEN
      num_of_iter <= 0;
    ELSIF( en_sequencing = '1' AND ctrl_store_addr = "000000" ) THEN
      num_of_iter <= num_of_iter + 1;      -- Increase the iteration no.
    -- ELSE, num_of_iter will remain latched in this duration
    END IF;

END PROCESS;

--------------process for controlling sequencer ---------------
PROCESS(en_decode, valid_word)
BEGIN
      IF( en_decode = '1' AND valid_word = '1' ) THEN
        en_sequencing <= '0';
      ELSIF( en_decode = '1' ) THEN
        en_sequencing <= '1';
      ELSE
        en_sequencing <= '0'; -- initial few cycles may be
      END IF;
END PROCESS;

no_iter     <= num_of_iter;
output      <= rxvd_code;
valid_cword <= valid_word;

--------------- process to start/stop microcode sequencing----------------
PROCESS(clk)
BEGIN
    IF (clk'event AND clk='1') THEN
      IF ( en_sequencing = '1' ) THEN -- already factors valid_word != 0
        en_mem          <= '1';
      ELSE
        en_mem          <= '0';
      END IF;
    END IF;
END PROCESS;
