void make_package_module()
{
    ofstream outfile(outputfile);
    outfile << "LIBRARY IEEE;\n";
    outfile << "USE IEEE.STD_LOGIC_1164.ALL;\n\n";
    outfile << "PACKAGE fold_package IS\n\n";

    outfile << "\tTYPE wr_addr_list\t\t\t\tIS ARRAY (0 to " << 23 << ") OF INTEGER;\n";
    outfile << "\tTYPE bus_instr_in\t\t\t\tIS ARRAY ( 0 to " << 14 << " ) OF    STD_LOGIC_VECTOR( " << 8 << " downto 0 );\n";
    outfile << "\tTYPE bus_fold_instr_in\t\t\t\tIS ARRAY ( 0 to " << 4 << " ) OF STD_LOGIC_VECTOR( " << 8 << " downto 0 );\n";
    outfile << "\tTYPE h2p_network\t\t\t\tIS  ARRAY(" << 24 << " DOWNTO 0) OF STD_LOGIC;\n";
    outfile << "\tTYPE p2h_network\t\t\t\tIS  ARRAY(" << 29 << " DOWNTO 0) OF STD_LOGIC;\n\n";

    outfile << "\tSUBTYPE out_bus \t\t\t\tIS STD_LOGIC_VECTOR(" << 14 << " downto 0);\n";
    outfile << "\tSUBTYPE bus_instr_vec\t\t\t\tIS STD_LOGIC_VECTOR( " << 8 << " downto 0 );\n";
    outfile << "\tSUBTYPE fold_indx\t\t\t\tIS STD_LOGIC_VECTOR( " << 1 << " downto 0 );\n";
    outfile << "\tSUBTYPE node_indx\t\t\t\tIS STD_LOGIC_VECTOR( " << 2 << " downto 0 );\n";
    outfile << "\tSUBTYPE pat_indx\t\t\t\tIS STD_LOGIC_VECTOR( " << 1 << " downto 0 );\n";
    outfile << "\tSUBTYPE addr_bus\t\t\t\tIS STD_LOGIC_VECTOR(" << 5 << " downto 0);\n";
    outfile << "\tSUBTYPE microcode_bus\t\t\t\tIS STD_LOGIC_VECTOR(" << 40 << " downto 0);\n";
    outfile << "\tSUBTYPE fold_bus\t\t\t\tIS STD_LOGIC_VECTOR(" << 4 << " downto 0);\n";
    outfile << "\tSUBTYPE procinpbus\t\t\t\tIS  STD_LOGIC_VECTOR(" << 4 << " DOWNTO 0);\n";
    outfile << "\tSUBTYPE fullinput\t\t\t\tIS  STD_LOGIC_VECTOR(" << 14 << " DOWNTO 0);\n\n";

    outfile << "\tCONSTANT no_unfolded_pap\t\t\t\t: INTEGER    := " << 4 << ";\n";
    outfile << "\tCONSTANT fold_factor\t\t\t\t: INTEGER    := " << 3 << ";\n";
    outfile << "\tCONSTANT is_deg_odd\t\t\t\t: BOOLEAN    := " << TRUE << ";\n\n";

    outfile << "END PACKAGE fold_package;\n";
    outfile.close();

    return;
}
