LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.STD_LOGIC_UNSIGNED.ALL;  -- CONV_INTEGER()
USE WORK.fold_package.ALL;

ENTITY tdp_mem IS
PORT (  clk     : IN STD_LOGIC;
        rst     : IN STD_LOGIC;
        en_mem  : IN STD_LOGIC;
        rwbar_1 : IN STD_LOGIC;
        rwbar_2 : IN STD_LOGIC;
        addr1   : IN mem_addr_bus;
        addr2   : IN mem_addr_bus;
        din_1   : IN STD_LOGIC;
        din_2   : IN STD_LOGIC;
        dout_1  : OUT STD_LOGIC;
        dout_2  : OUT STD_LOGIC
     );
END ENTITY tdp_mem;

ARCHITECTURE behav OF tdp_mem IS
        -- The size of memory is
        -- { 1 bit wide x (Order + [Order % 2]) x Fold_Factor }
        -- locations deep.

