LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.STD_LOGIC_ARITH.ALL;  -- CONV_STD_LOGIC_VECTOR( )
USE WORK.fold_package.ALL;

ENTITY hyp_wr_addrgen IS
        PORT ( clk          : IN STD_LOGIC;
               en_addrgen   : IN STD_LOGIC;
               mu_id        : IN node_indx;
               addr1        : OUT mem_addr_bus;
               addr2        : OUT mem_addr_bus
             );
END ENTITY hyp_wr_addrgen;

ARCHITECTURE behav OF hyp_wr_addrgen IS
    SIGNAL count1, count2 : INTEGER;  -- address counters
    SIGNAL addrcount      : INTEGER;  -- loop counter
