/*
 * Author: Utkarsh Gupta
 * Created on: June 5, 2012
 * File Name : make_mem_module..h
 * Project Name : Automation of Folding (DDP)
 * Description : Header File for make_mem_module.cpp
 */

#ifndef MEMORY_MODULE
#define MEMORY_MODULE
    void make_tdp_mem(int order, int fold_factor, const char* outputfile);
    void make_add_mux(int order, int fold_factor, std::string default_addr, const char* outputfile);
    void make_rd_addrgen(int order, int fold_factor, std::string default_addrZ, std::string default_addr0,    int mem_loc, const char* outputfile);
    void make_wr_addrgen(int order, int nodes, int fold_factor, int hyp_node[], std::string default_addrZ, int mem_loc, const char *outputfile1, const char *outputfile2);
    void make_mem_module(const char * outputfile1, const char * outputfile2);
#endif

