/*
 * Author: Utkarsh Gupta
 * Created on: June 5, 2012
 * File Name : auxiliary_functions.h
 * Project Name : Automation of Folding (DDP)
 * Description : Header file for auxiliary_functions.cpp
 */

#ifndef AUX_FUNCS
#define AUX_FUNCS
void sort( std::vector<int> numbers, int count );
void sort2( int *numbers, int count );
void append(const char * inputfile, const char * outputfile);
int exp(int k, int a);
int bin_digits(int a);
std::string binary(const int& number, const int& length_num);
int select_line(int edge_conn[], int num_edges, int id, int folded_nodes, int line_sel_val, int line_sel_num);
void fill_array( int *array, int start, int length, int num_to_fill );
void fill_seq( int *array, int start, int length, int period);
void fill_seq2( int **array, int start, int length, int period, int start_index, int size);
void fill_seq3( int **array, int start, int length, int period, int start_index, int size);
#endif

