p_p_switch_0:  p_p_switch PORT MAP( clk, en_p_switch_c, pat_id_c,
                                "00000", -- 0th unit
                                b_to_c_wires( 0 ),
                                b_to_c_wires( 1 ),
                                b_to_c_wires( 2 ),
                                b_to_c_wires( 3 ),
                                b_to_c_wires( 4 ),
                                b_to_c_wires( 5 ),
                                b_to_c_wires( 6 ),
                                b_to_c_wires( 7 ),
                                cfu_in1( 0 ), cfu_in2( 0 )
                                  );

p_p_switch_1:  p_p_switch PORT MAP( clk, en_p_switch_c, pat_id_c,
                                "00001", -- 1th unit
                                b_to_c_wires( 8 ),
                                b_to_c_wires( 9 ),
                                b_to_c_wires( 10 ),
                                b_to_c_wires( 11 ),
                                b_to_c_wires( 12 ),
                                b_to_c_wires( 13 ),
                                b_to_c_wires( 14 ),
                                b_to_c_wires( 15 ),
                                cfu_in1( 1 ), cfu_in2( 1 )
                                  );

p_p_switch_2:  p_p_switch PORT MAP( clk, en_p_switch_c, pat_id_c,
                                "00010", -- 2th unit
                                b_to_c_wires( 16 ),
                                b_to_c_wires( 17 ),
                                b_to_c_wires( 18 ),
                                b_to_c_wires( 19 ),
                                b_to_c_wires( 20 ),
                                b_to_c_wires( 21 ),
                                b_to_c_wires( 22 ),
                                b_to_c_wires( 23 ),
                                cfu_in1( 2 ), cfu_in2( 2 )
                                  );

p_p_switch_3:  p_p_switch PORT MAP( clk, en_p_switch_c, pat_id_c,
                                "00011", -- 3th unit
                                b_to_c_wires( 24 ),
                                b_to_c_wires( 25 ),
                                b_to_c_wires( 26 ),
                                b_to_c_wires( 27 ),
                                b_to_c_wires( 28 ),
                                b_to_c_wires( 29 ),
                                b_to_c_wires( 30 ),
                                b_to_c_wires( 31 ),
                                cfu_in1( 3 ), cfu_in2( 3 )
                                  );

p_p_switch_4:  p_p_switch PORT MAP( clk, en_p_switch_c, pat_id_c,
                                "00100", -- 4th unit
                                b_to_c_wires( 32 ),
                                b_to_c_wires( 33 ),
                                b_to_c_wires( 34 ),
                                b_to_c_wires( 35 ),
                                b_to_c_wires( 36 ),
                                b_to_c_wires( 37 ),
                                b_to_c_wires( 38 ),
                                b_to_c_wires( 39 ),
                                cfu_in1( 4 ), cfu_in2( 4 )
                                  );

p_p_switch_5:  p_p_switch PORT MAP( clk, en_p_switch_c, pat_id_c,
                                "00101", -- 5th unit
                                b_to_c_wires( 40 ),
                                b_to_c_wires( 41 ),
                                b_to_c_wires( 42 ),
                                b_to_c_wires( 43 ),
                                b_to_c_wires( 44 ),
                                b_to_c_wires( 45 ),
                                b_to_c_wires( 46 ),
                                b_to_c_wires( 47 ),
                                cfu_in1( 5 ), cfu_in2( 5 )
                                  );

p_p_switch_6:  p_p_switch PORT MAP( clk, en_p_switch_c, pat_id_c,
                                "00110", -- 6th unit
                                b_to_c_wires( 48 ),
                                b_to_c_wires( 49 ),
                                b_to_c_wires( 50 ),
                                b_to_c_wires( 51 ),
                                b_to_c_wires( 52 ),
                                b_to_c_wires( 53 ),
                                b_to_c_wires( 54 ),
                                b_to_c_wires( 55 ),
                                cfu_in1( 6 ), cfu_in2( 6 )
                                  );

p_p_switch_7:  p_p_switch PORT MAP( clk, en_p_switch_c, pat_id_c,
                                "00111", -- 7th unit
                                b_to_c_wires( 56 ),
                                b_to_c_wires( 57 ),
                                b_to_c_wires( 58 ),
                                b_to_c_wires( 59 ),
                                b_to_c_wires( 60 ),
                                b_to_c_wires( 61 ),
                                b_to_c_wires( 62 ),
                                b_to_c_wires( 63 ),
                                cfu_in1( 7 ), cfu_in2( 7 )
                                  );

p_p_switch_8:  p_p_switch PORT MAP( clk, en_p_switch_c, pat_id_c,
                                "01000", -- 8th unit
                                b_to_c_wires( 64 ),
                                b_to_c_wires( 65 ),
                                b_to_c_wires( 66 ),
                                b_to_c_wires( 67 ),
                                b_to_c_wires( 68 ),
                                b_to_c_wires( 69 ),
                                b_to_c_wires( 70 ),
                                b_to_c_wires( 71 ),
                                cfu_in1( 8 ), cfu_in2( 8 )
                                  );

p_p_switch_9:  p_p_switch PORT MAP( clk, en_p_switch_c, pat_id_c,
                                "01001", -- 9th unit
                                b_to_c_wires( 72 ),
                                b_to_c_wires( 73 ),
                                b_to_c_wires( 74 ),
                                b_to_c_wires( 75 ),
                                b_to_c_wires( 76 ),
                                b_to_c_wires( 77 ),
                                b_to_c_wires( 78 ),
                                b_to_c_wires( 79 ),
                                cfu_in1( 9 ), cfu_in2( 9 )
                                  );

p_p_switch_10:  p_p_switch PORT MAP( clk, en_p_switch_c, pat_id_c,
                                "01010", -- 10th unit
                                b_to_c_wires( 80 ),
                                b_to_c_wires( 81 ),
                                b_to_c_wires( 82 ),
                                b_to_c_wires( 83 ),
                                b_to_c_wires( 84 ),
                                b_to_c_wires( 85 ),
                                b_to_c_wires( 86 ),
                                b_to_c_wires( 87 ),
                                cfu_in1( 10 ), cfu_in2( 10 )
                                  );

p_p_switch_11:  p_p_switch PORT MAP( clk, en_p_switch_c, pat_id_c,
                                "01011", -- 11th unit
                                b_to_c_wires( 88 ),
                                b_to_c_wires( 89 ),
                                b_to_c_wires( 90 ),
                                b_to_c_wires( 91 ),
                                b_to_c_wires( 92 ),
                                b_to_c_wires( 93 ),
                                b_to_c_wires( 94 ),
                                b_to_c_wires( 95 ),
                                cfu_in1( 11 ), cfu_in2( 11 )
                                  );

p_p_switch_12:  p_p_switch PORT MAP( clk, en_p_switch_c, pat_id_c,
                                "01100", -- 12th unit
                                b_to_c_wires( 96 ),
                                b_to_c_wires( 97 ),
                                b_to_c_wires( 98 ),
                                b_to_c_wires( 99 ),
                                b_to_c_wires( 100 ),
                                b_to_c_wires( 101 ),
                                b_to_c_wires( 102 ),
                                b_to_c_wires( 103 ),
                                cfu_in1( 12 ), cfu_in2( 12 )
                                  );

p_p_switch_13:  p_p_switch PORT MAP( clk, en_p_switch_c, pat_id_c,
                                "01101", -- 13th unit
                                b_to_c_wires( 104 ),
                                b_to_c_wires( 105 ),
                                b_to_c_wires( 106 ),
                                b_to_c_wires( 107 ),
                                b_to_c_wires( 108 ),
                                b_to_c_wires( 109 ),
                                b_to_c_wires( 110 ),
                                b_to_c_wires( 111 ),
                                cfu_in1( 13 ), cfu_in2( 13 )
                                  );

p_p_switch_14:  p_p_switch PORT MAP( clk, en_p_switch_c, pat_id_c,
                                "01110", -- 14th unit
                                b_to_c_wires( 112 ),
                                b_to_c_wires( 113 ),
                                b_to_c_wires( 114 ),
                                b_to_c_wires( 115 ),
                                b_to_c_wires( 116 ),
                                b_to_c_wires( 117 ),
                                b_to_c_wires( 118 ),
                                b_to_c_wires( 119 ),
                                cfu_in1( 14 ), cfu_in2( 14 )
                                  );

p_p_switch_15:  p_p_switch PORT MAP( clk, en_p_switch_c, pat_id_c,
                                "01111", -- 15th unit
                                b_to_c_wires( 120 ),
                                b_to_c_wires( 121 ),
                                b_to_c_wires( 122 ),
                                b_to_c_wires( 123 ),
                                b_to_c_wires( 124 ),
                                b_to_c_wires( 125 ),
                                b_to_c_wires( 126 ),
                                b_to_c_wires( 127 ),
                                cfu_in1( 15 ), cfu_in2( 15 )
                                  );

p_p_switch_16:  p_p_switch PORT MAP( clk, en_p_switch_c, pat_id_c,
                                "10000", -- 16th unit
                                b_to_c_wires( 128 ),
                                b_to_c_wires( 129 ),
                                b_to_c_wires( 130 ),
                                b_to_c_wires( 131 ),
                                b_to_c_wires( 132 ),
                                b_to_c_wires( 133 ),
                                b_to_c_wires( 134 ),
                                b_to_c_wires( 135 ),
                                cfu_in1( 16 ), cfu_in2( 16 )
                                  );

p_p_switch_17:  p_p_switch PORT MAP( clk, en_p_switch_c, pat_id_c,
                                "10001", -- 17th unit
                                b_to_c_wires( 136 ),
                                b_to_c_wires( 137 ),
                                b_to_c_wires( 138 ),
                                b_to_c_wires( 139 ),
                                b_to_c_wires( 140 ),
                                b_to_c_wires( 141 ),
                                b_to_c_wires( 142 ),
                                b_to_c_wires( 143 ),
                                cfu_in1( 17 ), cfu_in2( 17 )
                                  );

p_p_switch_18:  p_p_switch PORT MAP( clk, en_p_switch_c, pat_id_c,
                                "10010", -- 18th unit
                                b_to_c_wires( 144 ),
                                b_to_c_wires( 145 ),
                                b_to_c_wires( 146 ),
                                b_to_c_wires( 147 ),
                                b_to_c_wires( 148 ),
                                b_to_c_wires( 149 ),
                                b_to_c_wires( 150 ),
                                b_to_c_wires( 151 ),
                                cfu_in1( 18 ), cfu_in2( 18 )
                                  );

