" ) THEN
      num_of_iter <= num_of_iter + 1;      -- Increase the iteration no.
    -- ELSE, num_of_iter will remain latched in this duration
    END IF;

END PROCESS;

--------------process for controlling sequencer ---------------
PROCESS(en_decode, valid_word)
BEGIN
      IF( en_decode = '1' AND valid_word = '1' ) THEN
        en_sequencing <= '0';
      ELSIF( en_decode = '1' ) THEN
        en_sequencing <= '1';
      ELSE
        en_sequencing <= '0'; -- initial few cycles may be
      END IF;
END PROCESS;

no_iter     <= num_of_iter;
output      <= rxvd_code;
valid_cword <= valid_word;

--------------- process to start/stop microcode sequencing----------------
PROCESS(clk)
BEGIN
    IF (clk'event AND clk='1') THEN
      IF ( en_sequencing = '1' ) THEN -- already factors valid_word != 0
        en_mem          <= '1';
      ELSE
        en_mem          <= '0';
      END IF;
    END IF;
END PROCESS;

END ARCHITECTURE Behavioral;
